Index: trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Routing.TSP.Views/3.3/TSPView.cs	(revision 2805)
@@ -0,0 +1,64 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Windows.Forms;
+using HeuristicLab.Core.Views;
+using HeuristicLab.MainForm;
+
+namespace HeuristicLab.Routing.TSP.Views {
+  /// <summary>
+  /// The base class for visual representations of items.
+  /// </summary>
+  [Content(typeof(TSP), true)]
+  public sealed partial class TSPView : ProblemView {
+    public new TSP Content {
+      get { return (TSP)base.Content; }
+      set { base.Content = value; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="ItemBaseView"/>.
+    /// </summary>
+    public TSPView() {
+      InitializeComponent();
+    }
+    /// <summary>
+    /// Intializes a new instance of <see cref="ItemBaseView"/> with the given <paramref name="item"/>.
+    /// </summary>
+    /// <param name="item">The item that should be displayed.</param>
+    public TSPView(TSP content)
+      : this() {
+      Content = content;
+    }
+
+    private void importButton_Click(object sender, System.EventArgs e) {
+      if (openFileDialog.ShowDialog(this) == DialogResult.OK) {
+        try {
+          Content.ImportFromTSPLIB(openFileDialog.FileName);
+        }
+        catch (Exception ex) {
+          Auxiliary.ShowErrorMessageBox(ex);
+        }
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2803)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLab.Routing.TSP-3.3.csproj	(revision 2805)
@@ -86,8 +86,11 @@
   <ItemGroup>
     <None Include="HeuristicLabRoutingTSPPlugin.cs.frame" />
+    <Compile Include="TSPDistanceMatrixPathEvaluator.cs" />
+    <Compile Include="TSPLIBParser.cs" />
+    <Compile Include="TSPRoundedEuclideanPathEvaluator.cs" />
+    <Compile Include="TSPPathEvaluator.cs" />
     <Compile Include="TSP.cs" />
     <Compile Include="HeuristicLabRoutingTSPPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="TSPParser.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -108,4 +111,8 @@
       <Name>HeuristicLab.Operators-3.3</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Permutation\3.3\HeuristicLab.Permutation-3.3.csproj">
       <Project>{00282156-589D-424F-9CE4-A8038636C926}</Project>
@@ -122,4 +129,6 @@
   </ItemGroup>
   <ItemGroup>
+    <None Include="ch130.tsp" />
+    <None Include="fl1400.tsp" />
     <None Include="HeuristicLab.snk" />
     <None Include="Properties\AssemblyInfo.frame" />
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2803)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/HeuristicLabRoutingTSPPlugin.cs.frame	(revision 2805)
@@ -32,4 +32,5 @@
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
   [PluginDependency("HeuristicLab.Permutation", "3.3")]
   [PluginDependency("HeuristicLab.Persistence", "3.3")]
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2803)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSP.cs	(revision 2805)
@@ -20,19 +20,57 @@
 #endregion
 
-using System;
-using System.Collections.Generic;
-using System.Text;
-using System.Xml;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Permutation;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
-namespace HeuristicLab.Data {
+namespace HeuristicLab.Routing.TSP {
   [Item("TSP", "Represents a symmetric Traveling Salesman Problem.")]
   [Creatable("Problems")]
+  [EmptyStorableClass]
   public sealed class TSP : Problem {
+    private ValueParameter<DoubleMatrixData> CoordinatesParameter {
+      get { return (ValueParameter<DoubleMatrixData>)Parameters["Coordinates"]; }
+    }
+    private OperatorParameter SolutionGeneratorParameter {
+      get { return (OperatorParameter)Parameters["SolutionGenerator"]; }
+    }
+    private OperatorParameter EvaluatorParameter {
+      get { return (OperatorParameter)Parameters["Evaluator"]; }
+    }
+
+    public DoubleMatrixData Coordinates {
+      get { return CoordinatesParameter.Value; }
+      set { CoordinatesParameter.Value = value; }
+    }
+    public IOperator SolutionGenerator {
+      get { return SolutionGeneratorParameter.Value; }
+      set { SolutionGeneratorParameter.Value = value; }
+    }
+    public IOperator Evaluator {
+      get { return EvaluatorParameter.Value; }
+      set { EvaluatorParameter.Value = value; }
+    }
+
     public TSP()
       : base() {
+      Parameters.Add(new ValueParameter<BoolData>("Maximization", "Set to false as the TSP is a minimization problem.", new BoolData(false)));
+      Parameters.Add(new ValueParameter<DoubleMatrixData>("Coordinates", "The x- and y-Coordinates of the cities.", new DoubleMatrixData(0, 0)));
+      Parameters.Add(new ValueParameter<DoubleData>("BestKnownQuality", "The quality of the best known solution of this TSP instance."));
+      Parameters.Add(new OperatorParameter("SolutionGenerator", "The operator which should be used to generate new solutions."));
+      Parameters.Add(new OperatorParameter("Evaluator", "The operator which should be used to evaluate solutions."));
+    }
 
+    public void ImportFromTSPLIB(string filename) {
+      TSPLIBParser parser = new TSPLIBParser(filename);
+      parser.Parse();
+      Coordinates = new DoubleMatrixData(parser.Vertices);
+      int cities = Coordinates.Rows;
+      RandomPermutationCreator creator = new RandomPermutationCreator();
+      creator.LengthParameter.Value = new IntData(cities);
+      SolutionGenerator = creator;
+      TSPRoundedEuclideanPathEvaluator evaluator = new TSPRoundedEuclideanPathEvaluator();
+      Evaluator = evaluator;
     }
   }
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPDistanceMatrixPathEvaluator.cs	(revision 2805)
@@ -0,0 +1,66 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// An operator which evaluates TSP solutions given in path representation using a distance matrix.
+  /// </summary>
+  [Item("TSPDistanceMatrixPathEvaluator", "An operator which evaluates TSP solutions given in path representation using a distance matrix.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public sealed class TSPDistanceMatrixPathEvaluator : SingleSuccessorOperator {
+    public LookupParameter<DoubleMatrixData> DistanceMatrixParameter {
+      get { return (LookupParameter<DoubleMatrixData>)Parameters["DistanceMatrix"]; }
+    }
+    public LookupParameter<Permutation.Permutation> PermutationParameter {
+      get { return (LookupParameter<Permutation.Permutation>)Parameters["Permutation"]; }
+    }
+    public LookupParameter<DoubleData> QualityParameter {
+      get { return (LookupParameter<DoubleData>)Parameters["Quality"]; }
+    }
+
+    public TSPDistanceMatrixPathEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleMatrixData>("DistanceMatrix", "The distance matrix of the cities."));
+      Parameters.Add(new LookupParameter<Permutation.Permutation>("Permutation", "The TSP solution given in path representation which should be evaluated."));
+      Parameters.Add(new LookupParameter<DoubleData>("Quality", "The evaluated quality of the given TSP solution."));
+    }
+
+    public override IExecutionSequence Apply() {
+      DoubleMatrixData distanceMatrix = DistanceMatrixParameter.ActualValue;
+      Permutation.Permutation permutation = PermutationParameter.ActualValue;
+
+      double length = 0;
+      for (int i = 0; i < permutation.Length - 1; i++)
+        length += distanceMatrix[permutation[i], permutation[i + 1]];
+      length += distanceMatrix[permutation[permutation.Length - 1], permutation[0]];
+      QualityParameter.ActualValue = new DoubleData(length);
+
+      return base.Apply();
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPLIBParser.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPLIBParser.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPLIBParser.cs	(revision 2805)
@@ -0,0 +1,208 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Globalization;
+using System.IO;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// Parses a *.tsp file in the TSPLIB format and extracts its information about a TSP.
+  /// </summary>
+  public class TSPLIBParser {
+    private const int EOF = 0;
+    private const int NAME = 1;
+    private const int TYPE = 2;
+    private const int DIM = 3;
+    private const int WEIGHTTYPE = 4;
+    private const int NODETYPE = 5;
+    private const int NODESECTION = 6;
+
+    private StreamReader source;
+
+    private string myName;
+    /// <summary>
+    /// Gets the name of the parsed TSP.
+    /// </summary>
+    public string Name {
+      get { return myName; }
+    }
+    private double[,] myVertices;
+    /// <summary>
+    /// Gets the vertices of the parsed TSP.
+    /// </summary>
+    public double[,] Vertices {
+      get { return myVertices; }
+    }
+    private int myWeightType;
+    /// <summary>
+    /// Gets the weight type of the parsed TSP.
+    /// </summary>
+    public int WeightType {
+      get { return myWeightType; }
+    }
+
+    /// <summary>
+    /// Initializes a new instance of <see cref="TSPParser"/> with the given <paramref name="path"/>.
+    /// </summary>
+    /// <exception cref="ArgumentException">Thrown when the input file name is not in TSP format (*.tsp)
+    /// </exception>
+    /// <param name="path">The path where the TSP is stored.</param>
+    public TSPLIBParser(String path) {
+      if (!path.EndsWith(".tsp"))
+        throw new ArgumentException("Input file name has to be in TSP format (*.tsp)");
+
+      source = new StreamReader(path);
+      myName = path;
+      myVertices = null;
+      myWeightType = -1;
+    }
+
+    /// <summary>
+    /// Reads the TSP file and parses the elements.
+    /// </summary>
+    /// <exception cref="InvalidDataException">Thrown when file contains unknown (edge) types.</exception>
+    public void Parse() {
+      int section = -1;
+      string str = null;
+      bool typeIsChecked = false;
+      bool weightTypeIsChecked = false;
+
+      do {
+        str = source.ReadLine();
+        section = GetSection(str);
+
+        if (section != -1) {
+          switch (section) {
+            case NAME:
+              ReadName(str);
+              break;
+            case TYPE:
+              CheckType(str);
+              typeIsChecked = true;
+              break;
+            case DIM:
+              InitVerticesArray(str);
+              break;
+            case WEIGHTTYPE:
+              ReadWeightType(str);
+              weightTypeIsChecked = true;
+              break;
+            case NODETYPE:
+              CheckNodeType(str);
+              break;
+            case NODESECTION:
+              ReadVertices();
+              break;
+          }
+        }
+      } while (!((section == EOF) || (str == null)));
+
+      if (!(typeIsChecked && weightTypeIsChecked))
+        throw new InvalidDataException("File contains unknown (edge) types");
+    }
+
+    private int GetSection(string str) {
+      if (str == null)
+        return EOF;
+
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+      if (tokens.Length == 0)
+        return -1;
+
+      string token = tokens[0].Trim();
+      if (token.Equals("eof", StringComparison.OrdinalIgnoreCase))
+        return EOF;
+      if (token.Equals("name", StringComparison.OrdinalIgnoreCase))
+        return NAME;
+      if (token.Equals("type", StringComparison.OrdinalIgnoreCase))
+        return TYPE;
+      if (token.Equals("dimension", StringComparison.OrdinalIgnoreCase))
+        return DIM;
+      if (token.Equals("edge_weight_type", StringComparison.OrdinalIgnoreCase))
+        return WEIGHTTYPE;
+      if (token.Equals("node_coord_type", StringComparison.OrdinalIgnoreCase))
+        return NODETYPE;
+      if (token.Equals("node_coord_section", StringComparison.OrdinalIgnoreCase))
+        return NODESECTION;
+
+      return -1;
+    }
+
+    private void ReadName(string str) {
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+      myName = tokens[tokens.Length - 1].Trim();
+    }
+
+    private void CheckType(string str) {
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+
+      string type = tokens[tokens.Length - 1].Trim();
+      if (!type.Equals("tsp", StringComparison.OrdinalIgnoreCase))
+        throw new InvalidDataException("Input data format is not \"TSP\"");
+    }
+
+    private void InitVerticesArray(string str) {
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+      string dimension = tokens[tokens.Length - 1].Trim();
+
+      int dim = Int32.Parse(dimension);
+      myVertices = new double[dim, 2];
+    }
+
+    private void ReadWeightType(string str) {
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+      string type = tokens[tokens.Length - 1].Trim();
+
+      if (type.Equals("euc_2d", StringComparison.OrdinalIgnoreCase))
+        myWeightType = 0;
+      else if (type.Equals("geo", StringComparison.OrdinalIgnoreCase))
+        myWeightType = 1;
+      else
+        throw new InvalidDataException("Unsupported type of edge weights");
+    }
+
+    private void CheckNodeType(string str) {
+      string[] tokens = str.Split(new string[] { ":" }, StringSplitOptions.None);
+      string type = tokens[tokens.Length - 1].Trim();
+
+      if (!type.Equals("twod_coords", StringComparison.OrdinalIgnoreCase))
+        throw new InvalidDataException("Unsupported node type");
+    }
+
+    private void ReadVertices() {
+      if (myVertices == null)
+        throw new InvalidDataException("Dimension not found");
+
+      for (int i = 0; i < (myVertices.Length / 2); i++) {
+        string str = source.ReadLine();
+        string[] tokens = str.Split(new string[] { " " }, StringSplitOptions.RemoveEmptyEntries);
+
+        if (tokens.Length != 3)
+          throw new InvalidDataException("Invalid node format");
+
+        CultureInfo culture = new CultureInfo("en-US");
+        myVertices[i, 0] = Double.Parse(tokens[1], culture.NumberFormat);
+        myVertices[i, 1] = Double.Parse(tokens[2], culture.NumberFormat);
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPPathEvaluator.cs	(revision 2805)
@@ -0,0 +1,81 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Operators;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// A base class for operators which evaluate TSP solutions given in path representation.
+  /// </summary>
+  [Item("TSPPathEvaluator", "A base class for operators which evaluate TSP solutions given in path representation.")]
+  [EmptyStorableClass]
+  public abstract class TSPPathEvaluator : SingleSuccessorOperator {
+    public LookupParameter<DoubleMatrixData> CoordinatesParameter {
+      get { return (LookupParameter<DoubleMatrixData>)Parameters["Coordinates"]; }
+    }
+    public LookupParameter<Permutation.Permutation> PermutationParameter {
+      get { return (LookupParameter<Permutation.Permutation>)Parameters["Permutation"]; }
+    }
+    public LookupParameter<DoubleData> QualityParameter {
+      get { return (LookupParameter<DoubleData>)Parameters["Quality"]; }
+    }
+
+    protected TSPPathEvaluator()
+      : base() {
+      Parameters.Add(new LookupParameter<DoubleMatrixData>("Coordinates", "The x- and y-Coordinates of the cities."));
+      Parameters.Add(new LookupParameter<Permutation.Permutation>("Permutation", "The TSP solution given in path representation which should be evaluated."));
+      Parameters.Add(new LookupParameter<DoubleData>("Quality", "The evaluated quality of the given TSP solution."));
+    }
+
+    public override IExecutionSequence Apply() {
+      DoubleMatrixData coordinates = CoordinatesParameter.ActualValue;
+      Permutation.Permutation permutation = PermutationParameter.ActualValue;
+
+      double length = 0;
+      for (int i = 0; i < permutation.Length - 1; i++)
+        length += CalculateDistance(coordinates[permutation[i], 0],
+                                    coordinates[permutation[i], 1],
+                                    coordinates[permutation[i + 1], 0],
+                                    coordinates[permutation[i + 1], 1]);
+      length += CalculateDistance(coordinates[permutation[permutation.Length - 1], 0],
+                                  coordinates[permutation[permutation.Length - 1], 1],
+                                  coordinates[permutation[0], 0],
+                                  coordinates[permutation[0], 1]);
+      QualityParameter.ActualValue = new DoubleData(length);
+
+      return base.Apply();
+    }
+
+    /// <summary>
+    /// Calculates the distance between two points.
+    /// </summary>
+    /// <param name="x1">The x-coordinate of point 1.</param>
+    /// <param name="y1">The y-coordinate of point 1.</param>
+    /// <param name="x2">The x-coordinate of point 2.</param>
+    /// <param name="y2">The y-coordinate of point 2.</param>
+    /// <returns>The calculated distance.</returns>
+    protected abstract double CalculateDistance(double x1, double y1, double x2, double y2);
+  }
+}
Index: trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPRoundedEuclideanPathEvaluator.cs
===================================================================
--- trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPRoundedEuclideanPathEvaluator.cs	(revision 2805)
+++ trunk/sources/HeuristicLab.Routing.TSP/3.3/TSPRoundedEuclideanPathEvaluator.cs	(revision 2805)
@@ -0,0 +1,46 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using HeuristicLab.Core;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Routing.TSP {
+  /// <summary>
+  /// An operator which evaluates TSP solutions given in path representation using the rounded Euclidean distance metric.
+  /// </summary>
+  [Item("TSPRoundedEuclideanPathEvaluator", "An operator which evaluates TSP solutions given in path representation using the rounded Euclidean distance metric.")]
+  [Creatable("Test")]
+  [EmptyStorableClass]
+  public sealed class TSPRoundedEuclideanPathEvaluator : TSPPathEvaluator {
+    /// <summary>
+    /// Calculates the distance between two points using the rounded Euclidean distance metric.
+    /// </summary>
+    /// <param name="x1">The x-coordinate of point 1.</param>
+    /// <param name="y1">The y-coordinate of point 1.</param>
+    /// <param name="x2">The x-coordinate of point 2.</param>
+    /// <param name="y2">The y-coordinate of point 2.</param>
+    /// <returns>The calculated distance.</returns>
+    protected override double CalculateDistance(double x1, double y1, double x2, double y2) {
+      return Math.Round(Math.Sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/HeuristicLab.Selection-3.3.csproj	(revision 2805)
@@ -82,6 +82,13 @@
   <ItemGroup>
     <None Include="HeuristicLabSelectionPlugin.cs.frame" />
+    <Compile Include="RightSelector.cs" />
+    <Compile Include="StochasticSelector.cs" />
+    <Compile Include="LeftSelector.cs" />
+    <Compile Include="RandomSelector.cs" />
+    <Compile Include="StochasticSingleObjectiveSelector.cs" />
     <Compile Include="HeuristicLabSelectionPlugin.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
+    <Compile Include="Selector.cs" />
+    <Compile Include="TournamentSelector.cs" />
   </ItemGroup>
   <ItemGroup>
@@ -90,4 +97,8 @@
   </ItemGroup>
   <ItemGroup>
+    <ProjectReference Include="..\..\HeuristicLab.Collections\3.3\HeuristicLab.Collections-3.3.csproj">
+      <Project>{958B43BC-CC5C-4FA2-8628-2B3B01D890B6}</Project>
+      <Name>HeuristicLab.Collections-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.3\HeuristicLab.Core-3.3.csproj">
       <Project>{C36BD924-A541-4A00-AFA8-41701378DDC5}</Project>
@@ -101,4 +112,12 @@
       <Project>{23DA7FF4-D5B8-41B6-AA96-F0561D24F3EE}</Project>
       <Name>HeuristicLab.Operators-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Parameters\3.3\HeuristicLab.Parameters-3.3.csproj">
+      <Project>{56F9106A-079F-4C61-92F6-86A84C2D84B7}</Project>
+      <Name>HeuristicLab.Parameters-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Persistence\3.3\HeuristicLab.Persistence-3.3.csproj">
+      <Project>{102BC7D3-0EF9-439C-8F6D-96FF0FDB8E1B}</Project>
+      <Name>HeuristicLab.Persistence-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
Index: trunk/sources/HeuristicLab.Selection/3.3/HeuristicLabSelectionPlugin.cs.frame
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/HeuristicLabSelectionPlugin.cs.frame	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/HeuristicLabSelectionPlugin.cs.frame	(revision 2805)
@@ -31,7 +31,10 @@
   [Plugin("HeuristicLab.Selection", "3.3.0.$WCREV$")]
   [PluginFile("HeuristicLab.Selection-3.3.dll", PluginFileType.Assembly)]
+  [PluginDependency("HeuristicLab.Collections", "3.3")]
   [PluginDependency("HeuristicLab.Core", "3.3")]
   [PluginDependency("HeuristicLab.Data", "3.3")]
   [PluginDependency("HeuristicLab.Operators", "3.3")]
+  [PluginDependency("HeuristicLab.Parameters", "3.3")]
+  [PluginDependency("HeuristicLab.Persistence", "3.3")]
   public class HeuristicLabSelectionPlugin : PluginBase {
   }
Index: trunk/sources/HeuristicLab.Selection/3.3/LeftSelector.cs
===================================================================
--- trunk/sources/HeuristicLab.Selection/3.3/LeftSelector.cs	(revision 2803)
+++ trunk/sources/HeuristicLab.Selection/3.3/LeftSelector.cs	(revision 2805)
@@ -1,5 +1,5 @@
 #region License Information
 /* HeuristicLab
- * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
  *
  * This file is part of HeuristicLab.
@@ -20,42 +20,33 @@
 #endregion
 
-using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
 
 namespace HeuristicLab.Selection {
   /// <summary>
-  /// Copies or moves a defined number of sub scopes from a source scope to a target scope, starting at
-  /// the left side of the tree.
+  /// An operator which selects sub-scopes from left to right.
   /// </summary>
-  public class LeftSelector : StochasticSelectorBase {
-    /// <inheritdoc select="summary"/>
-    public override string Description {
-      get { return @"TODO\r\nOperator description still missing ..."; }
-    }
+  [Item("LeftSelector", "An operator which selects sub-scopes from left to right.")]
+  [EmptyStorableClass]
+  [Creatable("Test")]
+  public sealed class LeftSelector : Selector {
+    public LeftSelector() : base() { }
 
-    /// <summary>
-    /// Copies or moves a number of sub scopes (<paramref name="selected"/>) from <paramref name="source"/>
-    /// starting at the left end to the <paramref name="target"/>.
-    /// </summary>
-    /// <param name="random">A random number generator.</param>
-    /// <param name="source">The source scope from which to copy/move the sub scopes.</param>
-    /// <param name="selected">The number of sub scopes to move. Can be also bigger than the total 
-    /// number of sub scopes in <paramref name="source"/>, then the copying process starts again from the 
-    /// beginning.</param>
-    /// <param name="target">The target where to copy/move the sub scopes.</param>
-    /// <param name="copySelected">Boolean flag whether the sub scopes shall be copied or moved.</param>
-    protected override void Select(IRandom random, IScope source, int selected, IScope target, bool copySelected) {
-      int index = 0;
-      for (int i = 0; i < selected; i++) {
-        if (copySelected) {
-          target.AddSubScope((IScope)source.SubScopes[index].Clone());
-          index++;
-          if (index >= source.SubScopes.Count) index = 0;
+    protected override void Select(ScopeList source, ScopeList target) {
+      int count = NumberOfSelectedSubScopesParameter.ActualValue.Value;
+      bool copy = CopySelectedParameter.Value.Value;
+
+      int j = 0;
+      for (int i = 0; i < count; i++) {
+        if (copy) {
+          target.Add((IScope)source[j].Clone());
+          j++;
+          if (j >= source.Count) j = 0;
         } else {
-          IScope s = source.SubScopes[0];
-          source.RemoveSubScope(s);
-          target.AddSubScope(s);
+          target.Add(source[0]);
+          source.RemoveAt(0);
         }
       }
